package com.reyun.sdktestdemo;

import android.util.Log;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInput;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;
import java.nio.channels.SocketChannel;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.zip.GZIPInputStream;
import java.util.zip.ZipInputStream;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class HttpServer extends NanoHTTPD {
    public HttpServer(int port) {
        super(port);
    }

    @Override
    public Response serve(IHTTPSession session) {
        if(!session.getMethod().equals(Method.POST)) return newFixedLengthResponse("not support GET");
        try{
            InputStream in = session.getInputStream();
            byte[] b = new byte[1024];
            int len;
            ByteArrayOutputStream bo = new ByteArrayOutputStream();
            DataInputStream di = new DataInputStream(in);
            byte[] key = new byte[16];
            byte[] iv = new byte[16];
            byte[] data_md5 = new byte[16];
            int ts;
            int data_len;
            if(di.read(key, 0, 16) == 16) {
                if(di.read(iv, 0, 16) == 16) {
                    ts = di.readInt();
                    if(di.read(data_md5, 0, 16) == 16) {
                        data_len = di.readInt();
                        byte[] data = new byte[data_len];
                        if(di.read(data, 0, data_len) == data_len) {
                            Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding");
                            SecretKeySpec skeySpec = new SecretKeySpec(key, "AES");
                            cipher.init(Cipher.DECRYPT_MODE, skeySpec, new IvParameterSpec(iv));
                            byte[] decodedData = cipher.doFinal(data);
                            ZipInputStream zis = new ZipInputStream(new ByteArrayInputStream(decodedData));
                            byte[] buf = new byte[1024];
                            ByteArrayOutputStream bo2 = new ByteArrayOutputStream();
                            int len2;
                            while((len2 = zis.read(buf, 0, 1024)) >= 0) {
                                bo2.write(buf, 0, len2);
                            }
                            byte[] ori_data = bo2.toByteArray();
                            Log.d("wdsdk", "ori_data: " + ori_data);
                        }
                    }
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
        } catch (BadPaddingException e) {
            e.printStackTrace();
        } catch (IllegalBlockSizeException e) {
            e.printStackTrace();
        } catch (InvalidAlgorithmParameterException e) {
            e.printStackTrace();
        } catch (InvalidKeyException e) {
            e.printStackTrace();
        }
        return newFixedLengthResponse("hahaha...");
    }
}
